import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load_module, reload_module, get_stdout, check_source

exercise = 'src.first_character'

@points('1.first_character')
class FirstCharacterTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[1] + ["2"] * 10):
           cls.module = load_module(exercise, 'en')

    def test_0_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_function_exists(self):
        with patch('builtins.input', side_effect=["2"] * 10):
            try:
                self.module.first_character("testing")
            except:
                self.assertTrue(False, f'Din kod bör innehålla en funktion som heter first_character, som kan anropas enligt följande:\nfirst_character("testning")')

    def test_correct_characters(self):
        for word in ["python", 'javascript', 'xyz', 'coder', 'vacation', 'night', 'programming', 'apple']:
          with patch('builtins.input', side_effect=["2"] * 10):   
            reload_module(self.module)
            output_at_start = get_stdout()
            self.module.first_character(word)
            output = get_stdout().replace(output_at_start, '', 1).replace('\n', '')
            self.assertTrue(len(output)>0, f'Att anropa funktionen first_character("{word}") skriver inte ut någonting')
            self.assertEqual(1, len(output), f'Funktionsanrop first_character("{word}") ska skriva ut endast ett tecken, nu skrivs det ut {len(output)} tecken, utskrift var\n{output}')
            self.assertEqual(word[0], output, f'Funktionsanrop first_character("{word}") bör skriva ut endast ett tecken, {word[0]}, nu skrivs det ut\n{output}')

if __name__ == '__main__':
    unittest.main()
